<?
 require_once($_path["include"]."dt.php");

 class Plugin_Backend_graphics extends Base_Plugin_Backend
 {
  function output()
  {
   global $_path;

   require_once($this->plugin->path["root"]."drawing.php");
   require_once($this->plugin->path["root"]."graph.php");
   require_once($this->plugin->path["root"]."flowchart.php");

   $output="";
   $output.="Drawing: ";
   $output.="<a href=\"".$this->plugin->url()."test=drawingDefault\">Default test</a>";
   $output.="<br/>";

   $output.="Graph: ";
   $output.="<a href=\"".$this->plugin->url()."test=graphDefault\">Default test</a> | ";
   $output.="<a href=\"".$this->plugin->url()."test=graphSimple\">Simple tests</a> | ";
   $output.="<a href=\"".$this->plugin->url()."test=graphExtended\">Extended tests</a> ";
   $output.="<br/>";

   $output.="Flow chart: ";
   $output.="<a href=\"".$this->plugin->url()."test=flowchartDefault\">Default test</a> | ";
   $output.="<a href=\"".$this->plugin->url()."test=flowchartSimple\">Simple tests</a> | ";
   $output.="<a href=\"".$this->plugin->url()."test=flowchartExtended\">Extended tests</a> ";
   $output.="<br/>";

   $output.="<br/>";
   if(request("test")=="drawingDefault")
    $output.=$this->drawingDefaultTests();
   else if(request("test")=="graphDefault")
    $output.=$this->graphDefaultTest();
   else if(request("test")=="graphSimple")
    $output.=$this->graphSimpleTests();
   else if(request("test")=="graphExtended")
    $output.=$this->graphExtendedTests();
   else if(request("test")=="flowchartDefault")
    $output.=$this->flowchartDefaultTest();
   else if(request("test")=="flowchartSimple")
    $output.=$this->flowchartSimpleTests();
   else if(request("test")=="flowchartExtended")
    $output.=$this->flowchartExtendedTests();
   else
    $output.=$this->drawingDefaultTests();

   return $output;
  }

  function drawingDefaultTests()
  {
   $dr=new Drawing();
   $r=$dr->style();

   $dr->color("drawing", false, "000088", "abcabc");
   $dr->grid("grid", "10,10");
   $dr->color("grid", "DDDDDD");
   $dr->line("test", "50,50", "300,100", "300,300", "150,300", "50,100", "50,50");
   $dr->corner("test2", "50,50", "300,100", "300,300", "150,300", "50,100", "50,50");
   $dr->corner("test3", "30,30");
   $dr->width("test3", 11);
   $dr->color("test", "0000FF88");
   $dr->color("test2", "FF000088");
   $dr->color("test3", "00FF0088");
   $dr->tooltip("test2", "test lala", 1);
   $dr->tooltip("test2", "test lala", 3);
   $dr->text("test", "test label", 1);
   $dr->size(400,400);

   $r.=$dr->render();

   $dr->clear();

   $dr->rectangle("test1", "200,50", "400,610");
   $dr->color("test1", "00FFFF60", "00FF00");
   $dr->border("test1", 5);
   $dr->border("test1", 5);

   $dr->rectangle("test2", "10,300", "500,410");
   $dr->color("test2", "FF00FF88", "FF0000", "FF0000");
   $dr->width("test2", 1);
   $dr->text("test2", "Text");
   $dr->textAlign("test2", "center", "bottom");
   $dr->tooltip("test2", "Tip tip tip", 0);

   $dr->rectangle("test3", "100,100", "700,310");
   $dr->color("test3", "FFFF0088");
   $dr->width("test3", 2);
   $dr->text("test3", "More text");
   $dr->textAlign("test3", "left", "top");

   for($x=200;$x<=400;$x+=50)
   {
    for($y=200;$y<=400;$y+=50)
    {
     $dr->line("test".$x.$y, "300,300", $x.",".$y);
     $dr->color("test".$x.$y, "FF0000");
    }
   }

   $r.=$dr->render();

   return $r;
  }


  /*
   * Graphs
   * */

  function graphDefaultTest()
  {
   $g=new Graph();
   $r=$g->style();

   $g->axis("x", "horizontal");
   $g->text("x", "X axis", 1);
   $g->grid("x");
   $g->color("x", "888888");
   $g->color("x_l1", false, false, "888888");
   $g->color("grid_x", "CCCCCC");
   $g->indicator("x");
   $g->labels("x");

   $g->axis("y", "x", 0);
   $g->text("y", "Y axis", 0);
   $g->grid("y");
   $g->margin("y", .1);
   $g->color("y", "8888CC");
   $g->color("y_l0", false, false, "8888CC");
   $g->color("grid_y", "CCCCFF");
   $g->indicator("y");
   $g->labels("y");

   $g->axis("y2", "x");
   $g->text("y2", "Y2 axis");
   $g->grid("y2");
   $g->margin("y2", .1);
   $g->display("y2", false, "s");
   $g->color("y2", "CC8888");
   $g->color("y2_l0", false, false, "CC8888");
   $g->color("grid_y2", "FFCCCC");
   $g->indicator("y2");
   $g->labels("y2");

   $start=DT::dateConvertS("2009-01-01 00:00:00", "Y-m-d H:i:s");

   $tmp=Array();
   for($c=0;$c<=10;$c++)
   {
    $tmp[]=date("Y-m-d H:i:s", $start+(86400*$c)).",".(pow($c, 2)-25);
   }

   $g->line("test1", "y2", $tmp);
   $g->color("test1", "CC8888", false, "CC8888");
   foreach($tmp as $k => $v)
    $g->text("test1", array_pop(explode(",", $v)), $k);

   for($c=5;$c<=15;$c+=2)
   {
    $g->bar("test_".$c, "y", date("Y-m-d H:i:s", $start+(43200*$c)).",".($c*2), 50);
    $g->color("test_".$c, "8888CC88", false, "FFFFFF");
    $g->text("test_".$c, $c*2);
   }

   $g->dateFormat("x", "Y-m-d");
   $r.=$g->render(640, 480)."<br/><br/>";

   return $r;
  }

  function graphSimpleTests()
  {
   $g=new Graph();
   $r=$g->style();

   $g->axis("x", "horizontal");
   $g->text("x", "X axis");
   $g->labels("x");
   $g->indicator("x");
   $g->grid("x", 2.5);
   $g->color("grid_x", "CCCCCC");

   $g->axis("y", "x");
   $g->text("y", "Y axis");

   $g->labels("y");
   $g->indicator("y");
   $g->grid("y", 25);
   $g->color("grid_y", "CCCCCC");

   $tmp=Array();
   for($c=0;$c<=10;$c+=1)
    $tmp[]=$c.",".pow($c, 2);

   $g->line("test1", "y", $tmp);
   $g->color("test1", "FF3333");

   $r.=$g->render(200, 100)."<br/><br/>";
   $g->tilt("x");
   $r.=$g->render(200, 100)."<br/><br/>";
   $g->tilt("x");

   $g->clear(true);

   $tmp=Array();
   for($c=-5;$c<=10;$c+=1)
    $tmp[]=$c.",".(pow($c, 2)-20);

   $g->line("test1", "y", $tmp);
   $g->color("test1", "FF3333");

   $r.=$g->render(200, 100)."<br/><br/>";
   $g->tilt("x");
   $r.=$g->render(200, 100)."<br/><br/>";
   $g->tilt("x");

   $g->clear(true);

   $tmp=Array();
   for($c=-10;$c<=0;$c+=1)
    $tmp[]=$c.",".pow($c, 2);

   $g->line("test1", "y", $tmp);
   $g->color("test1", "FF3333");

   $r.=$g->render(200, 100)."<br/><br/>";
   $g->tilt("x");
   $r.=$g->render(200, 100)."<br/><br/>";
   $g->tilt("x");

   $g->clear(true);

   //bars
   for($c=0;$c<=10;$c+=1)
   {
    $g->bar("test".$c, "y", $c.",".pow($c,2));
    $g->color("test".$c, "FF333388");
   }

   $r.=$g->render(200, 100)."<br/><br/>";
   $g->tilt("x");
   $r.=$g->render(200, 100)."<br/><br/>";
   $g->tilt("x");

   $g->clear(true);

   for($c=-5;$c<=10;$c+=1)
   {
    $g->bar("test".$c, "y", $c.",".(pow($c,2)-20));
    $g->color("test".$c, "FF333388");
   }

   $r.=$g->render(200, 100)."<br/><br/>";
   $g->tilt("x");
   $r.=$g->render(200, 100)."<br/><br/>";
   $g->tilt("x");

   $g->clear(true);

   for($c=-10;$c<=0;$c+=1)
   {
    $g->bar("test".$c, "y", $c.",".pow($c,2));
    $g->color("test".$c, "FF333388");
   }

   $r.=$g->render(200, 100)."<br/><br/>";
   $g->tilt("x");
   $r.=$g->render(200, 100)."<br/><br/>";
   $g->tilt("x");


   return $r;
  }

  function graphExtendedTests()
  {
   $g=new Graph();
   $r=$g->style();

   $g->axis("x", "horizontal");
   $g->text("x", "X axis", 1);
   $g->grid("x");
   $g->color("x", "000000");
   $g->color("x_l1", false, false, "000000");
   $g->color("grid_x", "CCCCCC");

   $g->axis("y", "x");
   $g->text("y", "Y axis", 0);
   $g->grid("y");
   $g->color("y", "000088");
   $g->color("y_l0", false, false, "000088");
   $g->color("grid_y", "CCCCFF");

   $g->axis("y2", "x");
   $g->text("y2", "Y2 axis", 0);
   $g->grid("y2");
   $g->color("y2", "880000");
   $g->color("y2_l0", false, false, "880000");
   $g->color("grid_y2", "FFCCCC");

   $g->axis("y3", "x");
   $g->text("y3", "Y3 axis", 0);
   $g->grid("y3");
   $g->color("y3", "008800");
   $g->color("y3_l0", false, false, "008800");
   $g->color("grid_y3", "CCFFCC");

   $tmp=Array();
   for($c=-10;$c<=10;$c+=1)
    $tmp[$c]=(pow($c, 2)-25);

   foreach($tmp as $k => $v)
   {
    $g->bar("test_".$k, "y", $k.",".$v);
    $g->color("test_".$k, "88880088");
    $g->text("test_".$k, $v);
   }

   $tmp=Array();
   for($c=-5;$c<=10;$c+=2)
   {
    $tmp=($c).",".(($c)*2);

    $g->line("test2_".$c, "y2", $tmp);
    $g->color("test2_".$c, "880088");
    $g->width("test2_".$c, 5);
    $g->text("test2_".$c, $tmp);
   }

   $tmp=Array();
   for($c=-10;$c<=10;$c+=2)
    $tmp[]=($c).",".(50-pow($c,2));

   $g->line("test3", "y3", $tmp);
   foreach($tmp as $k => $v)
    $g->tooltip("test3", "Y3: ".$v, $k);

   $r.=$g->render(640, 240)."<br/><br/>";

   $r.=$g->clear();

   $g->axis("x", "horizontal");
   $g->text("x", "X axis", 1);

   $g->axis("y", "x");
   $g->text("y", "Y axis", 1);

   $tmp=Array();
   for($c=-15;$c<=15;$c+=1)
    $tmp[]=($c).",".(1-sin($c/5)*10);

   $g->line("test1", "y", $tmp);
   $g->color("test1", "88008866");

   foreach($tmp as $k => $v)
    $g->tooltip("test1", $v, $k);

   $tmp=Array();
   for($c=-20;$c<=20;$c+=2)
    $tmp[]=($c).",".(20-$c);

   foreach($tmp as $k => $v)
   {
    $g->bar("test2_".$k, "y", $v, 25);
    $g->color("test2_".$k, "00888866");
    $g->text("test2_".$k, $v);
   }

   $r.=$g->render(640, 240)."<br/><br/>";

   $r.=$g->clear();

   $g->axis("x", "horizontal");
   $g->text("x", "Browser");

   $g->axis("y", "x", 0);
   $g->text("y", "% Usage");
   $g->grid("y");
   $g->color("grid_y", "CCCCCC");
   $g->indicator("y");
   $g->labels("y");

   $tmp=Array(
    "Internet Explorer 8" => 3.5,
    "Internet Explorer 7" => 23.2,
    "Internet Explorer 6" => 15.4,
    "Firefox 3" => 43.4,
    "Firefox 2" => 2.8,
    "Chrome" => 4.9,
    "Safari" => 3.0,
    "Opera" => 2.2,
   );

   foreach($tmp as $k => $v)
   {
    $g->bar("test2_".$k, "y", $k.",".$v, 25);
    $g->color("test2_".$k, 44448866, false, "FFFFFF");
    $g->text("test2_".$k, $k.": ".$v."%");
    $g->textAlign("test2_".$k, "right", "middle");
   }

   $g->tilt();
   $r.=$g->render(640, 240)."<br/><br/>";

   return $r;
  }

  
  /*
   * FlowChart
   * */

  function flowchartDefaultTest()
  {
   $fc=new FlowChart();
   $r=$fc->style();

   $fc->action();
   $fc->action();
   $fc->label();
   $fc->connector("action_01", "action_02");

   $fc->action("Action 1");
   $fc->action("Action 2");
   $fc->setPosition("Action 1", 100, 150);
   $fc->setPosition("Action 2", 250, 200);
   $fc->connector("Action 1", "Action 2", "line", "Connector 1+2");
   $fc->setPosition("Action 2", 250, 200);
   $fc->text("Connector 1+2", "Test");
   
   $fc->setColor("Action 1", "FFFFFF", "00FF00", "FF0000");
   $fc->setColor("Action 2", "FFFFFF", "00FF00", "FF0000");
   $fc->setColor("Connector 1+2", "FF0000", "00FF00");

   $fc->action("Action 3");
   $fc->action("Action 4");
   $fc->setPosition("Action 3", 400, 150);
   $fc->setPosition("Action 4", 550, 200);
   $fc->connector("Action 3", "Action 4", "corner", "Connector 3+4");

   $fc->text("Action 3", "Start");
   $fc->text("Action 4", "End");
   $fc->text("Connector 3+4", "Do");

   $fc->action("Action 5");
   $fc->action("Action 6");
   $fc->setPosition("Action 5", 300, 50);
   $fc->setPosition("Action 6", 600, 370);
   $fc->connector("Action 5", "Action 6", "corner", "Connector 5+6");
   $fc->setPoints("Connector 5+6", "top", "right");

   $fc->setColor("Connector 5+6", "FF0000", "00FF00");

   $r.=$fc->render(1250, 400)."<br/><br/>";
   return $r;
  }

  function flowchartSimpleTests()
  {
   $fc=new FlowChart();
   $r=$fc->style();


   //Horizontal
   $fc->action("Horizontal 1");
   $fc->action("Horizontal 2");
   $fc->setPosition("Horizontal 1", 100, 50);
   $fc->setPosition("Horizontal 2", 250, 50);
   $fc->connector("Horizontal 1", "Horizontal 2");
   
   $fc->action("Horizontal 3");
   $fc->action("Horizontal 4");
   $fc->setPosition("Horizontal 3", 250, 120);
   $fc->setPosition("Horizontal 4", 100, 120);
   $fc->connector("Horizontal 4", "Horizontal 3");


   //Vertical
   $fc->action("Vertical 1");
   $fc->action("Vertical 2");
   $fc->setPosition("Vertical 1", 400, 50);
   $fc->setPosition("Vertical 2", 400, 120);
   $fc->connector("Vertical 1", "Vertical 2");
   
   $fc->action("Vertical 3");
   $fc->action("Vertical 4");
   $fc->setPosition("Vertical 3", 550, 120);
   $fc->setPosition("Vertical 4", 550, 50);
   $fc->connector("Vertical 3", "Vertical 4");


   //Above
   $fc->action("Above 1");
   $fc->action("Above 2");
   $fc->setPosition("Above 1", 220, 290);
   $fc->setPosition("Above 2", 100, 190);
   $fc->connector("Above 1", "Above 2");

   $fc->action("Above 3");
   $fc->action("Above 4");
   $fc->setPosition("Above 3", 400, 290);
   $fc->setPosition("Above 4", 300, 190);
   $fc->connector("Above 3", "Above 4");

   $fc->action("Above 5");
   $fc->action("Above 6");
   $fc->setPosition("Above 5", 550, 290);
   $fc->setPosition("Above 6", 500, 190);
   $fc->connector("Above 5", "Above 6");
  
   $fc->action("Above 7");
   $fc->action("Above 8");
   $fc->setPosition("Above 7", 700, 290);
   $fc->setPosition("Above 8", 750, 190);
   $fc->connector("Above 7", "Above 8");
 
   $fc->action("Above 9");
   $fc->action("Above 10");
   $fc->setPosition("Above 9", 850, 290);
   $fc->setPosition("Above 10", 950, 190);
   $fc->connector("Above 9", "Above 10");
 
   $fc->action("Above 11");
   $fc->action("Above 12");
   $fc->setPosition("Above 11", 1030, 290);
   $fc->setPosition("Above 12", 1150, 190);
   $fc->connector("Above 11", "Above 12");


   //Below
   $fc->action("Below 1");
   $fc->action("Below 2");
   $fc->setPosition("Below 1", 220, 360);
   $fc->setPosition("Below 2", 100, 460);
   $fc->connector("Below 1", "Below 2");

   $fc->action("Below 3");
   $fc->action("Below 4");
   $fc->setPosition("Below 3", 400, 360);
   $fc->setPosition("Below 4", 300, 460);
   $fc->connector("Below 3", "Below 4");

   $fc->action("Below 5");
   $fc->action("Below 6");
   $fc->setPosition("Below 5", 550, 360);
   $fc->setPosition("Below 6", 500, 460);
   $fc->connector("Below 5", "Below 6");
  
   $fc->action("Below 7");
   $fc->action("Below 8");
   $fc->setPosition("Below 7", 700, 360);
   $fc->setPosition("Below 8", 750, 460);
   $fc->connector("Below 7", "Below 8");
 
   $fc->action("Below 9");
   $fc->action("Below 10");
   $fc->setPosition("Below 9", 850, 360);
   $fc->setPosition("Below 10", 950, 460);
   $fc->connector("Below 9", "Below 10");
 
   $fc->action("Below 11");
   $fc->action("Below 12");
   $fc->setPosition("Below 11", 1030, 360);
   $fc->setPosition("Below 12", 1150, 460);
   $fc->connector("Below 11", "Below 12");

   //Left
   $fc->action("Left 1");
   $fc->action("Left 2");
   $fc->setPosition("Left 1", 220, 600);
   $fc->setPosition("Left 2", 100, 530);
   $fc->connector("Left 1", "Left 2");

   $fc->action("Left 3");
   $fc->action("Left 4");
   $fc->setPosition("Left 3", 420, 570);
   $fc->setPosition("Left 4", 300, 530);
   $fc->connector("Left 3", "Left 4");

   $fc->action("Left 5");
   $fc->action("Left 6");
   $fc->setPosition("Left 5", 660, 540);
   $fc->setPosition("Left 6", 540, 530);
   $fc->connector("Left 5", "Left 6");

   $fc->action("Left 7");
   $fc->action("Left 8");
   $fc->setPosition("Left 7", 660, 610);
   $fc->setPosition("Left 8", 540, 620);
   $fc->connector("Left 7", "Left 8");

   $fc->action("Left 9");
   $fc->action("Left 10");
   $fc->setPosition("Left 9", 910, 530);
   $fc->setPosition("Left 10", 780, 570);
   $fc->connector("Left 9", "Left 10");

   $fc->action("Left 11");
   $fc->action("Left 12");
   $fc->setPosition("Left 11", 1100, 530);
   $fc->setPosition("Left 12", 980, 600);
   $fc->connector("Left 11", "Left 12");


   //Right
   $fc->action("Right 1");
   $fc->action("Right 2");
   $fc->setPosition("Right 1", 100, 690);
   $fc->setPosition("Right 2", 220, 760);
   $fc->connector("Right 1", "Right 2");

   $fc->action("Right 3");
   $fc->action("Right 4");
   $fc->setPosition("Right 3", 300, 690);
   $fc->setPosition("Right 4", 420, 730);
   $fc->connector("Right 3", "Right 4");

   $fc->action("Right 5");
   $fc->action("Right 6");
   $fc->setPosition("Right 5", 540, 690);
   $fc->setPosition("Right 6", 660, 700);
   $fc->connector("Right 5", "Right 6");

   $fc->action("Right 7");
   $fc->action("Right 8");
   $fc->setPosition("Right 7", 540, 780);
   $fc->setPosition("Right 8", 660, 770);
   $fc->connector("Right 7", "Right 8");

   $fc->action("Right 9");
   $fc->action("Right 10");
   $fc->setPosition("Right 9", 780, 730);
   $fc->setPosition("Right 10", 910, 690);
   $fc->connector("Right 9", "Right 10");

   $fc->action("Right 11");
   $fc->action("Right 12");
   $fc->setPosition("Right 11", 980, 760);
   $fc->setPosition("Right 12", 1100, 690);
   $fc->connector("Right 11", "Right 12");


   $r.=$fc->render(1250, 850)."<br/><br/>";
   return $r;
  }

  function flowchartExtendedTests()
  {
   $fc=new FlowChart();
   $r=$fc->style();

   $fc->action("Design");
   $fc->action("Build");
   $fc->action("Test scripts");
   $fc->action("Test");
   $fc->action("Implementation");

   $fc->setPosition("Design", 60, 70);
   $fc->setPosition("Build", 200, 40);

   $fc->setPosition("Test scripts", 200, 120);
   $fc->setPosition("Test", 350, 120);

   $fc->setPosition("Implementation", 500, 70);

   $fc->connector("Design", "Build");
   $fc->connector("Design", "Test scripts");
   $fc->connector("Test scripts", "Test");
   $fc->connector("Build", "Implementation");
   $fc->connector("Test", "Implementation");

   $fc->setPoints("connector_01", "right", "left");
   $fc->setPoints("connector_02", "right", "left");
   $fc->setPoints("connector_03", "right", "left");
   $fc->setPoints("connector_04", "right", "left");
   $fc->setPoints("connector_05", "right", "left");

   $r.=$fc->render(640, 480)."<br/><br/>";
   return $r;
  }
 }

?>
