<?
 require_once($_path["include"]."data.php");
 require_once($_path["include"]."errors.php");

 class Drawing
 {
  function __construct()
  {
   global $_session;

   $this->e=new Errors();
   $this->browser=preg_replace("/^([a-z\s]+) .*$/i", "\\1", $_session->get("browser"));

   $this->clear();
  }

  function style($inline=false)
  {
   global $_path;

   if($inline)
    $r="<style type=\"text/css\">".file_get_contents($_path["project"]["plugins"]."graphics/style/default.css")."</style>";
   else
    $r="<link rel=\"stylesheet\" type=\"text/css\" href=\"".$_path["HTML"]["current"].$_path["project"]["plugins"]."graphics/style/default.css\"/>";

   return $r;
  }

  function size($width=false, $height=false)
  {
   if($width!==false&&$width<10)
   {
    $this->e->add("Width needs to be at least 10", "error");
    return false;
   }

   if($height!==false&&$height<10)
   {
    $this->e->add("Height needs to be at least 10", "error");
    return false;
   }

   $this->width=$width;
   $this->height=$height;

   return true;
  }

  function clear()
  {
   $this->e->clear();

   $this->size();

   $this->items=Array();
   $this->order=0;

   $this->items["drawing"]=Array(
    "type" => "drawing",
    "order" => $this->order++,
    "width" => 1,
    "color" => $this->_color(false),
    "bColor" => $this->_color("000000"),
    "tColor" => $this->_color(false),
    "show" => true,
   );
  }

  function load($name)
  {
  }
  function save($name)
  {
  }

  function line($id, $c1/*, $c2, $c3, $c4, etc*/)
  {
   if(isset($this->items[$id]))
   {
    $this->e->add("Unable to add line, ID \"".$id."\" already exists", "error");
    return false;
   }

   $args=func_get_args();
   array_shift($args);

   if(is_array($args[0]))
    $args=$args[0];

   if(sizeof($args)<1)
   {
    $this->e->add("Unable to add line, ID \"".$id."\" needs at least 1 coordinate", "error");
    return false;
   }

   $this->items[$id]=Array(
    "type" => "line",
    "order" => $this->order++,
    "width" => 1,
    "color" => $this->_color("000000"),
    "show" => true,
   );

   if(!$this->coords($id, $args))
   {
    unset($this->items[$id]);
    return false;
   }

   return true;
  }

  function corner($id, $c1 /*, $c2, $c3, $c4, etc*/)
  {
   if(isset($this->items[$id]))
   {
    $this->e->add("Unable to add corner, ID \"".$id."\" already exists", "error");
    return false;
   }

   $args=func_get_args();
   array_shift($args);

   if(is_array($args[0]))
    $args=$args[0];

   if(sizeof($args)<1)
   {
    $this->e->add("Unable to add corder, ID \"".$id."\" needs at least 1 coordinate", "error");
    return false;
   }

   $this->items[$id]=Array(
    "type" => "corner",
    "order" => $this->order++,
    "width" => 1,
    "color" => $this->_color("000000"),
    "show" => true,
   );

   if(!$this->coords($id, $args))
   {
    unset($this->items[$id]);
    return false;
   }

   return true;
  }

  function grid($id, $c1)
  {
   if(isset($this->items[$id]))
   {
    $this->e->add("Unable to add grid, ID \"".$id."\" already exists", "error");
    return false;
   }

   $this->items[$id]=Array(
    "type" => "grid",
    "order" => $this->order++,
    "width" => 1,
    "color" => $this->_color("000000"),
    "intervals" => $this->_coords($c1),
    "show" => true,
   );

   return true;
  }

  function rectangle($id, $c1, $c2)
  {
   if(isset($this->items[$id]))
   {
    $this->e->add("Unable to add rectangle, ID \"".$id."\" already exists", "error");
    return false;
   }

   $this->items[$id]=Array(
    "type" => "rectangle",
    "text" => "",
    "order" => $this->order++,
    "width" => 0,
    "color" => $this->_color("FFFFFF"),
    "bColor" => $this->_color("000000"),
    "tColor" => $this->_color(false),
    "show" => true,
   );

   $this->textAlign($id, "center", "middle");

   if(!$this->coords($id, $c1, $c2))
   {
    unset($this->items[$id]);
    return false;
   }

   return true;
  }

  function coords($id, $c1/*, $c2, $c3, $c4, etc*/)
  {
   if(!isset($this->items[$id]))
   {
    $this->e->add("Can't set coordinates, ID \"".$id."\" doesn't exists", "error");
    return false;
   }

   //get arguments
   $args=func_get_args();
   array_shift($args); //remove id from list

   if(is_array($args[0])) //use first entry if it's an array
    $args=$args[0];

   $this->items[$id]["coords"]=Array(); //new list

   if($this->items[$id]["type"]=="corner") //corner
   {
    $prevs=false;
    for($c=0;$c<sizeof($args);$c++)
    {
     $coords=$this->_coords($args[$c]);

     if($prevs) //make corners
     {
      $width=$prevs[0]-$coords[0];
      $height=$prevs[1]-$coords[1];

      if($width!=0&&$height!=0) //diagonal
      {
       if($width<0)
        $width*=-1;
       if($height<0)
        $height*=-1;

       if($width<$height) //add longest corner point
        $this->items[$id]["coords"][]=Array($prevs[0], $coords[1], $coords[2]);
       else
        $this->items[$id]["coords"][]=Array($coords[0], $prevs[1], $coords[2]);
      }
     }

     $this->items[$id]["coords"][]=$coords;

     $prevs=$coords;
    }
   }
   else //lines, rectangles, etc
   {
    for($c=0;$c<sizeof($args);$c++)
     $this->items[$id]["coords"][]=$this->_coords($args[$c]);
   }

   return true;
  }

  function text($id, $text=false, $coord=0)
  {
   if(!isset($this->items[$id]))
   {
    $this->e->add("Can't set text, ID \"".$id."\" doesn't exists", "error");
    return false;
   }

   if($text===false)
    $text=$id;

   if($this->items[$id]["type"]=="rectangle"||$this->items[$id]["type"]=="label")
   {
    $this->items[$id]["text"]=$text;
   }
   else if($this->items[$id]["type"]=="line"||$this->items[$id]["type"]=="corner")
   {
    $this->items[$id."_l".$coord]=Array(
     "type" => "label",
     "text" => $text,
     "order" => $this->order++,
     "width" => 0,
     "color" => $this->_color(false),
     "bColor" => $this->_color("000000"),
     "tColor" => $this->items[$id]["color"],
     "id" => $id,
     "coord" => $coord,
    "show" => true,
    );

    $this->textAlign($id."_l".$coord);
   }
   else
   {
    $this->e->add("Can't set label color for non line/block with ID \"".$id."\" ", "error");
    return false;
   }

   return true;
  }

  function tooltip($id, $text, $coord=0)
  {
   if(!isset($this->items[$id]))
   {
    $this->e->add("Can't set tool-tip, ID \"".$id."\" doesn't exists", "error");
    return false;
   }

   if($this->items[$id]["type"]!="rectangle"&&$this->items[$id]["type"]!="label"&&$this->items[$id]["type"]!="line"&&$this->items[$id]["type"]!="corner")
   {
    $this->e->add("Can't set label color for non line/block with ID \"".$id."\" ", "error");
    return false;
   }

   $this->items[$id."_t".$coord]=Array(
    "type" => "tooltip",
    "text" => $text,
    "order" => -1,
    "width" => 1,
    "color" => $this->_color("FFFFCCEE"),
    "bColor" => $this->_color("000000"),
    "tColor" => $this->_color("000000"),
    "id" => $id,
    "coord" => $coord,
    "show" => true,
   );

   $this->textAlign($id."_t".$coord);

   return true;
  }

  function color($id, $color, $bColor=false, $tColor=false)
  {
   if(isset($this->items[$id]))
    $this->items[$id]["color"]=$this->_color($color);
   else
   {
    $this->e->add("Can't set color, ID \"".$id."\" doesn't exists", "error");
    return false;
   }

   if($bColor||$tColor)
   {
    if($this->items[$id]["type"]=="line"||$this->items[$id]["type"]=="corner")
    {
     foreach(array_keys($this->items) as $tid)
     {
      if($this->items[$tid]["type"]=="label"&&$this->items[$tid]["id"]==$id)
      {
       if($bColor)
        $this->items[$tid]["bColor"]=$this->_color($bColor);
       if($tColor)
        $this->items[$tid]["tColor"]=$this->_color($tColor);
      }
     }
    }
    else if($this->items[$id]["type"]!="rectangle"&&$this->items[$id]["type"]!="drawing"&&$this->items[$id]["type"]!="label")
    {
     $this->e->add("Can't set border/text color for non block with ID \"".$id."\" ", "error");
     return false;
    }
    else
    {
     if($bColor)
      $this->items[$id]["bColor"]=$this->_color($bColor);
     if($tColor)
      $this->items[$id]["tColor"]=$this->_color($tColor);
    }
   }

   return true;
  }

  function textAlign($id, $horizontal=false, $vertical=false)
  {
   if(!isset($this->items[$id]))
   {
    $this->e->add("Can't align text, ID \"".$id."\" doesn't exists", "error");
    return false;
   }

   if($this->items[$id]["type"]!="rectangle"&&$this->items[$id]["type"]!="label"&&$this->items[$id]["type"]!="tooltip")
   {
    $this->e->add("Can't align text for non block with ID \"".$id."\" ", "error");
    return false;
   }

   if($horizontal=="center"||$horizontal=="right")
    $this->items[$id]["textHorizontalAlign"]=$horizontal;
   else
    $this->items[$id]["textHorizontalAlign"]="left";

   if($vertical=="middle"||$vertical=="bottom")
    $this->items[$id]["textVerticalAlign"]=$vertical;
   else
    $this->items[$id]["textVerticalAlign"]="top";

   return true;
  }

  function width($id, $width)
  {
   if(!($width>=0))
   {
    $this->e->add("Width needs to be 0 or higher for ID \"".$id."\"", "error");
    return false;
   }

   if(!isset($this->items[$id]))
   {
    $this->e->add("Can't set width, ID \"".$id."\" doesn't exists", "error");
    return false;
   }

   $this->items[$id]["width"]=$width;
   return true;
  }

  function border($id, $width)
  {
   if(!($width>=0))
   {
    $this->e->add("Border needs to be 0 or higher for ID \"".$id."\"", "error");
    return false;
   }

   if(!isset($this->items[$id]))
   {
    $this->e->add("Can't set border, ID \"".$id."\" doesn't exists", "error");
    return false;
   }

   if($this->items[$id]["type"]!="rectangle"&&$this->items[$id]["type"]!="drawing"&&$this->items[$id]["type"]!="label")
   {
    $this->e->add("Can't set border for non block with ID \"".$id."\" ", "error");
    return false;
   }

   $this->items[$id]["width"]=$width;
   return true;
  }

  function show($id)
  {
   if(!isset($this->items[$id]))
   {
    $this->e->add("Can't show item, ID \"".$id."\" doesn't exists", "error");
    return false;
   }

   $this->items[$id]["show"]=true;
   return true;
  }

  function hide($id)
  {
   if(!isset($this->items[$id]))
   {
    $this->e->add("Can't hide item, ID \"".$id."\" doesn't exists", "error");
    return false;
   }

   $this->items[$id]["show"]=false;
   return true;
  }

  function render()
  {
   $size=$this->_getSize();

   if($this->width!==false)
    $width=$this->width;
   else
    $width=$size[1][0]-$size[0][0];

   if($this->height!==false)
    $height=$this->height;
   else
    $height=$size[1][1]-$size[0][1];

   $color=$this->_colorCSS($this->items["drawing"]["color"]);
   $bColor=$this->_colorCSS($this->items["drawing"]["bColor"]);
   $tColor=$this->_colorCSS($this->items["drawing"]["tColor"]);

   $style="";
   if($color[0]!="TRANSPARENT")
    $style.="background:#".$color[0].";";

   if($color[1]<1)
   {
    if($this->browser=="Internet Explorer")
     $style.="filter:alpha(opacity=".($color[1]*100).");";
    else
     $style.="opacity:".$color[1].";";
   }

   if($tColor[0]!="TRANSPARENT")
    $style.="color:#".$tColor[0].";";

   if($this->items["drawing"]["width"]&&$bColor[0]!="TRANSPARENT")
   {
    $style.="border:solid #".$bColor[0]." ".$this->items["drawing"]["width"]."px;";
    $style.="margin:-".$this->items["drawing"]["width"]."px 0px 0px -".$this->items["drawing"]["width"]."px;";
   }

   $r="<div class=\"drawing\" style=\"".$style."px;width:".$width."px;height:".$height."px;\">";

   $ids=array_keys($this->items);
   for($order=0;$order<$this->order;$order++)
   {
    foreach($ids as $id)
    {
     if($this->items[$id]["show"]&&$this->items[$id]["order"]==$order)
     {
      switch($this->items[$id]["type"])
      {
       case "line":
       {
        $r.=$this->_drawLineID($id);
        break;
       }
       case "corner":
       {
        $r.=$this->_drawLineID($id);
        break;
       }
       case "label":
       {
        $id2=$this->items[$id]["id"];
        $coord=$this->items[$id]["coord"];
        if($this->items[$id2]["show"]&&isset($this->items[$id2]["coords"][$coord]))
         $r.=$this->_drawRectangleID($id);

        break;
       }
       case "rectangle":
       {
        $r.=$this->_drawRectangleID($id);
        break;
       }
       case "grid":
       {
        $r.=$this->_drawGridID($id, $width, $height);
        break;
       }
       case "drawing":
       {
        break;
       }
       default:
       {
        $this->e->add("Unknown type \"".$this->items[$id]["type"]."\" for ID \"".$id."\"", "error");
        break;
       }
      }
     }
    }
   }

   foreach($ids as $id)
    if($this->items[$id]["show"]&&$this->items[$id]["type"]=="tooltip")
      $r.=$this->_drawToolTipID($id);

   $r.="</div>";
   $r.="<div style=\"height: ".($height+$this->items["drawing"]["width"])."px;\"></div>";

   if($this->e->any())
    $r.=$this->e->show();

   return $r;
  }

  function _drawLineID($id)
  {
   $items=sizeof($this->items[$id]["coords"])-1;

   $r="";

   if($items==0)
   {
    $tmp1=$this->items[$id]["coords"][0];
    $tmp2=$this->items[$id]["coords"][0];

    $r.=$this->_drawLine($this->items[$id]["color"], $this->items[$id]["width"], $tmp1, $tmp2);
   }
   else
    for($c=0;$c<$items;$c++)
     $r.=$this->_drawLine($this->items[$id]["color"], $this->items[$id]["width"], $this->items[$id]["coords"][$c], $this->items[$id]["coords"][$c+1]);

   return $r;
  }

  function _drawLine($color, $width, $c1, $c2)
  {
   $color=$this->_colorCSS($color);

   if($color[0]=="TRANSPARENT"||$color[1]==0) //invisible
    return "";

   $style="";
   if($color[0]!="TRANSPARENT")
    $style.="background:#".$color[0].";";

   if($color[1]<1)
   {
    if($this->browser=="Internet Explorer")
     $style.="filter:alpha(opacity=".($color[1]*100).");";
    else
     $style.="opacity:".$color[1].";";
   }

   for($c=0;$c<3;$c++)
   {
    $c1[$c]=ceil($c1[$c]);
    $c2[$c]=ceil($c2[$c]);
   }

   $w=$c2[0]-$c1[0];
   $h=$c2[1]-$c1[1];

   $w2=$w>0?$w:-$w;
   $h2=$h>0?$h:-$h;

   $r="";
   if($w2<$h2) //(near) vertical line
   {
    if($w>0) //left to right
    {
     $xt=$c1[0];
     $yt=$c1[1];
    }
    else
    {
     $xt=$c2[0];
     $yt=$c2[1];
    }

    $xt-=floor(($width-1)/2);

    if(($w>0&&$h>0)||($w<0&&$h<0)) //to bottom
     $yt-=floor(($width-1)/2);
    else if(($w>0&&$h<0)||($w<0&&$h>0)) //to top
     $yt+=floor(($width-1)/2)+1;

    $wt=$width;
    $hf=($h2+$width)/($w2+1);
    $ht=round($hf);

    for($c=0;$c<=$w2;$c++)
    {
     if($w==0) //vertical
     {
      if($h>0)
      {
       $yt-=$ht;
       $yt+=ceil(($width)/2);
      }
      else
       $yt-=ceil(($width-1)/2);
     }
     else if(($w>0&&$h<0)||($w<0&&$h>0)) //to top
     {
      if(round($yt)-(round($yt-$hf))>$ht) //rounding fix
       $ht++;
      else
       $ht=round($hf);

      $yt-=$hf;
     }
     else if(($w>0&&$h>0)||($w<0&&$h<0)) //to bottom
     {
      if((round($yt+$hf)-round($yt))>$ht) //round fix
       $ht++;
      else
       $ht=round($hf);
     }

     $r.="<div class=\"l\" style=\"".$style."width:".$wt."px;height:".$ht."px;margin:".round($yt)."px 0px 0px ".$xt."px;\"></div>";

     if(($w>0&&$h>0)||($w<0&&$h<0)) //to bottom
      $yt+=$hf;

     $xt++;
    }
   }
   else //(near) horizontal or diagonal line
   {
    if($h>0)
    {
     $xt=$c1[0];
     $yt=$c1[1];
    }
    else
    {
     $xt=$c2[0];
     $yt=$c2[1];
    }

    $yt-=floor(($width-1)/2);

    if(($w>0&&$h>0)||($w<0&&$h<0)) //to bottom
     $xt-=floor(($width-1)/2);
    else if(($w>0&&$h<0)||($w<0&&$h>0)) //to top
     $xt+=floor(($width-1)/2)+1;

    $ht=$width;
    $wf=round(($w2+$width)/($h2+1), 2);
    $wt=round($wf);

    for($c=0;$c<=$h2;$c++)
    {
     if($h==0) //horizontal
     {
      if($w>0)
      {
       $xt-=$wt;
       $xt+=ceil(($width)/2);
      }
      else
       $xt-=ceil(($width-1)/2);
     }
     else if(($w>0&&$h<0)||($w<0&&$h>0)) //to top
     {
      if(round($xt)-(round($xt-$wf))>$wt) //rounding fix
       $wt++;
      else
       $wt=round($wf);

      $xt-=$wf;
     }
     else if(($w>0&&$h>0)||($w<0&&$h<0)) //to bottom
     {
      if((round($xt+$wf)-round($xt))>$wt) //round fix
       $wt++;
      else
       $wt=round($wf);
     }

     $r.="<div class=\"l\" style=\"".$style."width:".$wt."px;height:".$ht."px;margin:".$yt."px 0px 0px ".round($xt)."px;\"></div>";

     if(($w>0&&$h>0)||($w<0&&$h<0)) //to bottom
      $xt+=$wf;

     $yt++;
    }
   }

   return $r;
  }

  function _drawRectangleID($id)
  {
   if($this->items[$id]["type"]=="label")
   {
    $id2=$this->items[$id]["id"];
    $coord=$this->items[$id]["coord"];
    if(isset($this->items[$id2]["coords"][$coord]))
     $c1=$this->items[$id2]["coords"][$coord];
    else
     $c1=$this->items[$id2]["coords"][$coord];

    $c2=false;
   } 
   else
   {
    $c1=$this->items[$id]["coords"][0];
    $c2=$this->items[$id]["coords"][1];
   }

   $r=$this->_drawRectangle($this->items[$id]["color"], $this->items[$id]["bColor"], $this->items[$id]["tColor"], $this->items[$id]["width"], $c1, $c2, $this->items[$id]["text"], $this->items[$id]["textHorizontalAlign"], $this->items[$id]["textVerticalAlign"], preg_replace("/[^A-Z0-9]+/i", "_", $id)." ".$this->items[$id]["type"]);

   return $r;
  }

  function _drawRectangle($color, $bColor, $tColor, $width, $c1, $c2, $text, $textHorz, $textVert, $class=false)
  {
   $color=$this->_colorCSS($color);
   $bColor=$this->_colorCSS($bColor);
   $tColor=$this->_colorCSS($tColor);

   if($color[1]==0) //invisible
    return "";

   for($c=0;$c<3;$c++)
   {
    $c1[$c]=ceil($c1[$c]);
    if(isset($c2[$c]))
     $c2[$c]=ceil($c2[$c]);
   }

   if($c2===false) //no end point
   {
    $xt=$c1[0];
    $yt=$c1[1];
    $wt=0;
    $ht=0;
   }
   else
   {
    if($c1[0]<$c2[0])
    {
     $xt=$c1[0];
     $wt=$c2[0]-$c1[0];
    }
    else if($c1[0]>$c2[0])
    {
     $xt=$c2[0];
     $wt=$c1[0]-$c2[0];
    }
    else
    {
     $xt=$c1[0];
     $wt=0;
    }

    if($c1[1]<$c2[1])
    {
     $yt=$c1[1];
     $ht=$c2[1]-$c1[1];
    }
    else if($c1[1]>$c2[1])
    {
     $yt=$c2[1];
     $ht=$c1[1]-$c2[1];
    }
    else
    {
     $yt=$c1[1];
     $ht=0;
    }

    $xt-=$width;
    $yt-=$width;
   }

   $xt=round($xt, 1);
   $yt=round($yt, 1);
   $wt=round($wt, 1);
   $ht=round($ht, 1);

   $style="";
   if($color[0]!="TRANSPARENT")
    $style.="background:#".$color[0].";";

   if($color[1]<1)
   {
    if($this->browser=="Internet Explorer")
     $style.="filter:alpha(opacity=".($color[1]*100).");";
    else
     $style.="opacity:".$color[1].";";
   }

   if($tColor[0]!="TRANSPARENT")
    $style.="color:#".$tColor[0].";";

   if($width&&$bColor[0]!="TRANSPARENT")
    $style.="border:solid #".$bColor[0]." ".$width."px;";

   if($text)
   {
    if($textHorz!="left")
     $style.="text-align:".$textHorz.";";
 
    if($textVert=="middle")
    {
     $style.="padding:".(($ht/2)-10)."px 0px 0px 0px;";
     $ht-=(($ht/2)-10);
    }
    else if($textVert=="bottom")
    {
     $style.="padding:".($ht-20)."px 0px 0px 0px;";
     $ht=20;
    }
   }

   if($c2!==false)
   {
    $style.="width:".$wt."px;";
    $style.="height:".$ht."px;";
   }

   if($class)
    $class="b ".$class;
   else
    $class="b";

   $r="<div class=\"".$class."\" style=\"".$style."margin:".$yt."px 0px 0px ".$xt."px;\">".$text."</div>";

   return $r;
  }

  function _drawGridID($id, $width, $height)
  {
   $r="";
   if($this->items[$id]["intervals"][0])
    for($c=0;$c<$width;$c+=$this->items[$id]["intervals"][0])
     $r.=$this->_drawLine($this->items[$id]["color"], 1, Array($c, 0, 0), Array($c, $height-1, 0));

   if($this->items[$id]["intervals"][1])
    for($c=$height;$c>0;$c-=$this->items[$id]["intervals"][1])
     $r.=$this->_drawLine($this->items[$id]["color"], 1, Array(0, $c, 0), Array($width-1, $c, 0));

   if($this->items[$id]["intervals"][2]) //depth
    $this->e->add("Depth grid drawing not yet support");

   return $r;
  }

  function _drawToolTipID($id)
  {
   $iid=$this->items[$id]["id"];

   if($this->items[$iid]["type"]=="line"||$this->items[$iid]["type"]=="corner")
    $r=$this->_drawRectangle($this->items[$id]["color"], $this->items[$id]["bColor"], $this->items[$id]["tColor"], $this->items[$id]["width"], $this->items[$iid]["coords"][$this->items[$id]["coord"]], false, $this->items[$id]["text"], $this->items[$id]["textHorizontalAlign"], $this->items[$id]["textVerticalAlign"], $iid." ".$this->items[$id]["type"]);
   else
    $r=$this->_drawRectangle($this->items[$id]["color"], $this->items[$id]["bColor"], $this->items[$id]["tColor"], $this->items[$id]["width"], $this->items[$iid]["coords"][0], false, $this->items[$id]["text"], $this->items[$id]["textHorizontalAlign"], $this->items[$id]["textVerticalAlign"], $iid." ".$this->items[$id]["type"]);

   return $r; 
  }

  function _color($color)
  {
   if($color===false)
    $codes=Array(-1, -1, -1, 255);
   else if(preg_match("/^#?([0-9a-f\-]+)$/i", $color, $m)) //hex
   {
    $codes=Array(0, 0, 0, 255);

    $m=$m[1];

    if(strlen($m)==8) //optional transparency
     $l=4;
    else
     $l=3;

    for($c=0;$c<$l;$c++)
    {
     if(($col=substr($m, $c*2, 2))=="-1")
      $codes[$c]=-1;
     else
      $codes[$c]=hexdec($col);
    }
   }

   return $codes;
  }

  function _colorCSS($color)
  {
   if($color[0]==-1||$color[1]==-1||$color[2]==-1)
   {
    $r="transparent";
    $g="";
    $b="";
   }
   else
   {
    $r=dechex($color[0]);
    if(strlen($r)==1)
     $r="0".$r;

    $g=dechex($color[1]);
    if(strlen($g)==1)
     $g="0".$g;

    $b=dechex($color[2]);
    if(strlen($b)==1)
     $b="0".$b;
   }

   $a=number_format(($color[3]/255), 2);

   return Array(strtoupper($r.$g.$b), $a);
  }

  function _getSize()
  {
   $x1=$x2=0;
   $y1=$y2=0;
   $z1=$z2=0;

   foreach(array_keys($this->items) as $id)
   {
    if(isset($this->items[$id]["coords"]))
    {
     foreach($this->items[$id]["coords"] as $coord)
     {
      if($coord[0]+$this->items[$id]["width"]<$x1)
       $x1=$coord[0]+$this->items[$id]["width"];
      if($coord[0]+$this->items[$id]["width"]>$x2)
       $x2=$coord[0]+$this->items[$id]["width"];

      if($coord[1]+$this->items[$id]["width"]<$y1)
       $y1=$coord[1]+$this->items[$id]["width"];
      if($coord[1]+$this->items[$id]["width"]>$y2)
       $y2=$coord[1]+$this->items[$id]["width"];

      if($coord[2]+$this->items[$id]["width"]<$z1)
       $z1=$coord[2]+$this->items[$id]["width"];
      if($coord[2]+$this->items[$id]["width"]>$z2)
       $z2=$coord[2]+$this->items[$id]["width"];
     }
    }
   }

   return Array(Array($x1, $y1, $z1), Array($x2, $y2, $z2));
  }

  function _coords($coords)
  {
   $codes=Array(0, 0, 0);

   $c=0;
   if(is_array($coords))
   {
    foreach($coords as $coord)
     $codes[$c++]=$coord;
   }
   else
   {
    foreach(explode(",", $coords) as $coord)
     $codes[$c++]=$coord;
   }

   return $codes;
  }
 }

?>
