<?
 require_once($_path["include"]."module.php");

 class Plugin_Module_graphics_pluginConfigs extends Module
 {
  function __construct(&$data)
  {
   global $_path;

   parent::__construct($data);

   $this->dataSets=4;
   $this->axis=Array("X", "Y1", "Y2", "Y3");

   if($this->data->module!="pluginConfigs")
    $this->extend("pluginConfigs");

   $this->data->title="Graphics plugin configuration";

   $this->data->addField("style", "enum", "all", "", false, false, "Horizontal", "X axis style");
   $this->data->enumOptions("style", "Horizontal", "Vertical");

   $this->data->addField("width", "nr", "all", "", 10, 1600, 800, "Width");
   $this->data->addField("height", "nr", "all", "", 10, 1200, 600, "Height");
   $this->data->addField("border", "nr", "all", "dropdown", 0, 20, 0, "Border width");

   $axis=$this->axis;
   array_shift($axis);
   for($c=1;$c<=$this->dataSets;$c++)
   {
    $this->data->addField("axis_".$c, "enum", "all", "reload", false, false, $axis[0], "Axis");
    $this->data->enumOptions("axis_".$c, $axis);

    $this->data->addField("type_".$c, "enum", "all", "reload", false, false, "line", "Type");
    $this->data->enumOptions("type_".$c, "line", "point", "bar");

    $this->data->addField("set_type_".$c, "enum", "all", "reload", false, false, "static", "Set");
    $this->data->enumOptions("set_type_".$c, "static", "data");

    $this->data->addField("set_".$c, "text", "all", "", 0, 255, "", "Static set", "Values: x,y x,y");

    $this->data->addField("data_set_".$c, "nr", "all", "reload", 0, false, "", "Data set");
    $this->data->addReference("data_set_".$c, "dataset", "nr", "*:0");

    $this->data->addField("base_field_".$c, "list", "all", "", 0, 255, "", "Base field (mapped to X)");
    $this->data->addField("values_field_".$c, "list", "all", "", 0, 255, "", "Values field (mapped to Y)");

    $this->data->addField("color_".$c, "text", "all", "", 0, 8, "000000FF", "Color");
    $this->data->addField("show_values_".$c, "boolean", "all", "", false, false, false, "Show values");

    $this->data->addField("line_width_".$c, "nr", "all", "dropdown", 1, 100, 1, "Line width");
    $this->data->addField("bar_width_".$c, "nr", "all", "dropdown", 0, 100, 1, "Border width");
    $this->data->addField("bar_size_".$c, "nr", "all", "dropdown", 1, 100, 1, "Bar size");

    if($c==1)
     array_unshift($axis, "None"); //additional data sets not required
   }

   foreach($this->axis as $axe)
   {
    $this->data->addField("title_".$axe, "text", "all", "", 0, 50, "", "Axis title");
    $this->data->addField("color_".$axe, "text", "all", "", 0, 6, "000000", "Axis color");
    $this->data->addField("grid_".$axe, "boolean", "all", "", false, false, false, "Grid");
    $this->data->addField("grid_color_".$axe, "text", "all", "", 0, 6, "CCCCCC", "Grid color");
    $this->data->addField("indicators_".$axe, "boolean", "all", "", false, false, false, "Indicators");
    
    $this->data->addField("labels_".$axe, "boolean", "all", "reload", false, false, false, "Labels");
    $this->data->addField("labels_color_".$axe, "text", "all", "", 0, 6, "000000", "Labels color");
    $this->data->addField("labels_display_".$axe, "enum", "all", "reload", false, false, "auto", "Labels formatting");
    $this->data->enumOptions("labels_display_".$axe, "auto", "date", "size");
    $this->data->addField("labels_append_".$axe, "text", "all", "", 0, 25, "", "Labels append");
    $this->data->addField("labels_dateformat_".$axe, "text", "all", "", 0, 25, "", "Labels date/time format");

    $this->data->addField("lock_min_".$axe, "boolean", "all", "reload", false, false, false, "Lock minimum");
    $this->data->addField("min_".$axe, "nr", "all", "big", false, false, "", "Minimum");
    $this->data->addField("lock_max_".$axe, "boolean", "all", "reload", false, false, false, "Lock maximum");
    $this->data->addField("max_".$axe, "nr", "all", "big", false, false, "", "Maximum");

    $this->data->addField("margin_".$axe, "nr", "all", "", 0, 100, 0, "Additional margin percentage");
    $this->data->addField("interval_".$axe, "float", "all", "", 0, false, 0, "Scale interval");
   }

   $this->data->group("Graph", "style", "width", "height", "border");

   for($c=1;$c<=$this->dataSets;$c++)
    $this->data->group("Data set ".$c, "axis_".$c, "type_".$c, "set_type_".$c, "set_".$c, "data_set_".$c, "base_field_".$c, "values_field_".$c, "color_".$c, "show_values_".$c, "line_width_".$c, "bar_width_".$c, "bar_size_".$c);

   foreach($this->axis as $axe)
    $this->data->group($axe." axis", "title_".$axe, "color_".$axe, "grid_".$axe, "grid_color_".$axe, "labels_".$axe, "labels_color_".$axe, "labels_display_".$axe, "labels_append_".$axe, "labels_dateformat_".$axe, "indicators_".$axe, "min_".$axe, "max_".$axe, "lock_min_".$axe, "lock_max_".$axe, "margin_".$axe, "interval_".$axe);
  }


  function postInit(){return $this->customizeFields();}
  function editPostGet(){return $this->customizeFields();}
  function deletePostGet(){return $this->customizeFields();}
  function movePostGet(){return $this->customizeFields();}
  function ownerPostGet(){return $this->customizeFields();}

  function customizeFields()
  {
   $previousDataSet=true;
   for($c=1;$c<=$this->dataSets;$c++)
   {
    if(!$previousDataSet)
    {
     $this->data->setValue("axis_".$c, "None");
     $this->data->field["axis_".$c]["properties"].=";hidden";
    }
    else
     $this->data->resetField("axis_".$c);

    if($this->data->getValue("axis_".$c)=="None")
    {
     $previousDataSet=false;

     $this->data->unsetValue("base_field_".$c);
     $this->data->unsetValue("values_field_".$c);

     $this->data->field["type_".$c]["properties"].=";hidden";
     $this->data->field["line_width_".$c]["properties"].=";hidden";
     $this->data->field["bar_width_".$c]["properties"].=";hidden";
     $this->data->field["bar_size_".$c]["properties"].=";hidden";
     $this->data->field["set_type_".$c]["properties"].=";hidden";
     $this->data->field["set_".$c]["properties"].=";hidden";
     $this->data->field["data_set_".$c]["properties"].=";hidden";
     $this->data->field["base_field_".$c]["properties"].=";hidden";
     $this->data->field["values_field_".$c]["properties"].=";hidden";
     $this->data->field["color_".$c]["properties"].=";hidden";
     $this->data->field["show_values_".$c]["properties"].=";hidden";
    }
    else
    {
     $previousDataSet=true;

     $this->data->resetField("type_".$c);

     if($this->data->getValue("type_".$c)=="line"||$this->data->getValue("type_".$c)=="point")
     {
      $this->data->resetField("line_width_".$c);

      $this->data->field["bar_width_".$c]["properties"].=";hidden";
      $this->data->field["bar_size_".$c]["properties"].=";hidden";

      if($this->data->getValue("type_".$c)=="point")
       $this->data->field["line_width_".$c]["title"]="Point size";
     }
     else if($this->data->getValue("type_".$c)=="bar")
     {
      $this->data->field["line_width_".$c]["properties"].=";hidden";

      $this->data->resetField("bar_width_".$c);
      $this->data->resetField("bar_size_".$c);
     }


     $this->data->resetField("set_type_".$c);

     if($this->data->getValue("set_type_".$c)=="static")
     {
      $this->data->field["data_set_".$c]["properties"].=";hidden";
      $this->data->field["base_field_".$c]["properties"].=";hidden";
      $this->data->field["values_field_".$c]["properties"].=";hidden";

      $this->data->resetField("set_".$c);
     }
     else if($this->data->getValue("set_type_".$c)=="data")
     {
      $this->data->field["set_".$c]["properties"].=";hidden";

      $this->data->resetField("data_set_".$c);

      if($this->data->getValue("data_set_".$c))
      {
       $this->data->resetField("base_field_".$c);
       $this->data->resetField("values_field_".$c);

       $d=Data::cache("dataset", "view", "item");
       $d->setValue("nr", $this->data->getValue("data_set_".$c));
       $d->setShowFields("module");

       if($d->get()&&$d->next())
       {
        $d=Data::cache($d->v["module"], "view", "item");
        $this->data->listOptions("base_field_".$c, $d->check("use", "show"));
        $this->data->listOptions("values_field_".$c, $d->check("use", "show"));
       }
      }
      else
      {
       $this->data->field["base_field_".$c]["properties"].=";hidden";
       $this->data->field["values_field_".$c]["properties"].=";hidden";
      }
     }

     $this->data->resetField("color_".$c);
     $this->data->resetField("show_values_".$c);
    }
   }

   $axis=Array("X");
   for($c=1;$c<=$this->dataSets;$c++)
   {
    if($this->data->getValue("axis_".$c)!="None")
     $axis[]=$this->data->getValue("axis_".$c);
   }

   foreach($this->axis as $axe)
   {
    if(!in_array($axe, $axis))
    {
     $this->data->field["title_".$axe]["properties"].=";hidden";
     $this->data->field["color_".$axe]["properties"].=";hidden";
     $this->data->field["grid_".$axe]["properties"].=";hidden";
     $this->data->field["grid_color_".$axe]["properties"].=";hidden";
     $this->data->field["indicators_".$axe]["properties"].=";hidden";
     $this->data->field["labels_".$axe]["properties"].=";hidden";
     $this->data->field["labels_color_".$axe]["properties"].=";hidden";
     $this->data->field["labels_display_".$axe]["properties"].=";hidden";
     $this->data->field["labels_append_".$axe]["properties"].=";hidden";
     $this->data->field["labels_dateformat_".$axe]["properties"].=";hidden";
     $this->data->field["min_".$axe]["properties"].=";hidden";
     $this->data->field["max_".$axe]["properties"].=";hidden";
     $this->data->field["lock_min_".$axe]["properties"].=";hidden";
     $this->data->field["lock_max_".$axe]["properties"].=";hidden";
     $this->data->field["margin_".$axe]["properties"].=";hidden";
     $this->data->field["interval_".$axe]["properties"].=";hidden";
    }
    else
    {
     $this->data->resetField("title_".$axe);
     $this->data->resetField("color_".$axe);
     $this->data->resetField("grid_".$axe);
     $this->data->resetField("grid_color_".$axe);
     $this->data->resetField("indicators_".$axe);


     $this->data->resetField("labels_".$axe);

     if($this->data->getValue("labels_".$axe))
     {
      $this->data->resetField("labels_color_".$axe);
      $this->data->resetField("labels_display_".$axe);

      if($this->data->getValue("labels_display_".$axe)!="date")
      {
       $this->data->resetField("labels_append_".$axe);
       $this->data->field["labels_dateformat_".$axe]["properties"].=";hidden";
      }
      else
      {
       $this->data->field["labels_append_".$axe]["properties"].=";hidden";
       $this->data->resetField("labels_dateformat_".$axe);
      }
     }
     else
     {
      $this->data->field["labels_color_".$axe]["properties"].=";hidden";
      $this->data->field["labels_display_".$axe]["properties"].=";hidden";
      $this->data->field["labels_append_".$axe]["properties"].=";hidden";
      $this->data->field["labels_dateformat_".$axe]["properties"].=";hidden";
     }


     $this->data->resetField("lock_min_".$axe);

     if($this->data->getValue("lock_min_".$axe))
      $this->data->resetField("min_".$axe);
     else
      $this->data->field["min_".$axe]["properties"].=";hidden";


     $this->data->resetField("lock_max_".$axe);

     if($this->data->getValue("lock_max_".$axe))
      $this->data->resetField("max_".$axe);
     else
      $this->data->field["max_".$axe]["properties"].=";hidden";


     $this->data->resetField("margin_".$axe);
     $this->data->resetField("interval_".$axe);
    }
   }

   return true;
  }

  function addPreSubmitErrorCheck()
  {
   $succes=true;

   if(!$this->checkAxis())
    $succes=false;
   if(!$this->checkDataSets())
    $succes=false;

   return $succes;
  }

  function editPreSubmitErrorCheck()
  {
   $succes=true;

   if(!$this->checkAxis())
    $succes=false;
   if(!$this->checkDataSets())
    $succes=false;

   return $succes;
  }

  function checkAxis()
  {
   $succes=true;

   foreach($this->axis as $axe)
   {
    for($x=0;$x<$this->data->vmax;$x++)
    {
     if($this->data->getValue("lock_min_".$axe, $x)&&$this->data->getValue("lock_max_".$axe, $x))
     {
      if($this->data->getValue("min_".$axe, $x)>=$this->data->getValue("max_".$axe, $x))
      {
       $this->data->e->add("Maximum needs to be higher then minimum for axe \"".$axe."\" for entry: ".($x+1), "error");
       $succes=false;
      }
     }

     if(!preg_match("/^[0-9A-F]{6}$/", $this->data->getValue("color_".$axe, $x)))
     {
      $this->data->e->add($this->data->field["color_".$axe]["title"]." code: \"".$this->data->getValue("color_".$axe, $x)."\" incorrect for entry: ".($x+1), "error");
      $succes=false;
     }
     if(!preg_match("/^[0-9A-F]{6}$/", $this->data->getValue("grid_color_".$axe, $x)))
     {
      $this->data->e->add($this->data->field["grid_color_".$axe]["title"]." code: \"".$this->data->getValue("grid_color_".$axe, $x)."\" incorrect for entry: ".($x+1), "error");
      $succes=false;
     }
     if(!preg_match("/^[0-9A-F]{6}$/", $this->data->getValue("labels_color_".$axe, $x)))
     {
      $this->data->e->add($this->data->field["labels_color_".$axe]["title"]." code: \"".$this->data->getValue("labels_color_".$axe, $x)."\" incorrect for entry: ".($x+1), "error");
      $succes=false;
     }
    }
   }

   return $succes;
  }

  function checkDataSets()
  {
   $succes=true;

   for($c=1;$c<=$this->dataSets;$c++)
   {
    for($x=0;$x<$this->data->vmax;$x++)
    {
     if($this->data->getValue("axis_".$c, $x)!="None")
     {
      if($this->data->getValue("set_type_".$c)=="static")
      {
       if(!preg_match("/^([0-9\.]+,[0-9\.]+\s?)+$/", $this->data->getValue("set_".$c, $x)))
       {
        $this->data->e->add($this->data->field["set_".$c]["title"].": \"".$this->data->getValue("set_".$c, $x)."\" incorrect for entry: ".($x+1), "error");
        $succes=false;
       }
      }
      else if($this->data->getValue("set_type_".$c)=="data")
      {
       if(!$this->data->getValue("data_set_".$c))
       {
        $this->data->e->add($this->data->field["data_set_".$c]["title"]." not set for entry: ".($x+1), "error");
        $succes=false;
       }
       else if(!$this->data->getValue("base_field_".$c))
       {
        $this->data->e->add($this->data->field["base_field_".$c]["title"]." not set for entry: ".($x+1), "error");
        $succes=false;
       }
       else if(!$this->data->getValue("values_field_".$c))
       {
        $this->data->e->add($this->data->field["values_field_".$c]["title"]." not set for entry: ".($x+1), "error");
        $succes=false;
       }
      }

      if(!preg_match("/^[0-9A-F]{6,8}$/", $this->data->getValue("color_".$c, $x)))
      {
       $this->data->e->add($this->data->field["color_".$c]["title"]." code: \"".$this->data->getValue("color_".$c, $x)."\" incorrect for entry: ".($x+1), "error");
       $succes=false;
      }
     }
    }
   }

   return $succes;
  }

 }
?>
